This section will allow you to import the assets used in the newletters from Ecolyo

## Export assets

In Ecolyo project, open a terminal in "/src/assets" folder and run 
```
docker build . -t registry.forge.grandlyon.com/web-et-numerique/llle_project/backoffice-client:assets
docker push registry.forge.grandlyon.com/web-et-numerique/llle_project/backoffice-client:assets
```
This will create a small docker image containing all the images needed, converted in png format, and push it to the container registry in the backoffice-client repository.

## Import assets

In the rec or prod server, create a import_assets.sh file and add execution permission. 

Copy the following content, replacing USERNAME and PASSWORD by the project access token
```
#!/bin/bash

#Login and pull assets container image
docker login -u USERNAME -p PASSWORD https://registry.forge.grandlyon.com/v2/web-et-numerique/llle_project/backoffice-client
docker pull registry.forge.grandlyon.com/web-et-numerique/llle_project/backoffice-client:assets

# Instanciate container
docker rm assets
docker run --name assets -it registry.forge.grandlyon.com/web-et-numerique/llle_project/backoffice-client:assets sh

# Copy files
sudo rm -rf ../image-lib
sudo docker cp assets:/image-lib ../image-lib

# Give permission to the container user
sudo chown -R 1000:1000 ../image-lib
```

To import assets for the ecogesture images, run
```
sudo sh scripts/import_assets.sh
```

Check that a "image-lib" folder has been created, that it contains a "ecogesture" folder and some images and that the owner of the "image-lib" folder is the user id 1000.

